## net.sf.saxon.expr
Class RangeExpression

    java.lang.Object
      |
      +--net.sf.saxon.expr.ComputedExpression
            |
            +--net.sf.saxon.expr.BinaryExpression
                  |
                  +--net.sf.saxon.expr.RangeExpression

All Implemented Interfaces:
  Container, Expression, InstructionInfoProvider, java.io.Serializable, javax.xml.transform.SourceLocator

public class RangeExpression
extends net.sf.saxon.expr.BinaryExpression

A RangeExpression is an expression that represents an integer sequence as a pair of end-points (for example "x to y"). If the end-points are equal, the sequence is of length one.

From Saxon 7.8, the sequence must be ascending; if the end-point is less than the start-point, an empty sequence is returned. This is to allow expressions of the form "for $i in 1 to count($seq) return ...."

See Also:
  Serialized Form

Nested Class Summary
`static class` `RangeExpression.RangeIterator` Iterator that produces numeric values in a monotonic sequence, ascending or descending

Field Summary
`protected Expression` `operand0`
`protected Expression` `operand1`
`protected int` `operator`

Fields inherited from class net.sf.saxon.expr.ComputedExpression
`locationId, staticProperties`

Fields inherited from interface net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`RangeExpression(Expression start, int op, Expression end)` Construct a RangeExpression

Method Summary
`Expression` `analyze(StaticContext env, ItemType contextItemType)` Type-check the expression
`int` `computeCardinality()` Determine the static cardinality
`void` `display(int level, NamePool pool, java.io.PrintStream out)` Diagnostic print of expression structure
`protected java.lang.String` `displayOperator()`
`boolean` `equals(java.lang.Object other)` Is this expression the same as another expression?
`ItemType` `getItemType()` Get the data type of the items returned
`int` `hashCode()` get HashCode for comparing two expressions.
`protected static boolean` `isCommutative(int operator)`
`SequenceIterator` `iterate(XPathContext context)` Return an iteration over the sequence
`java.util.Iterator` `iterateSubExpressions()` Get the immediate subexpressions of this expression
`Expression` `promote(PromotionOffer offer)` Promote this expression if possible
`Expression` `simplify(StaticContext env)` Simplify an expression

Methods inherited from class net.sf.saxon.expr.ComputedExpression

`adoptChildExpression, computeDependencies, computeSpecialProperties, computeStaticProperties, dynamicError, dynamicError, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getConstructType, getDependencies, getExecutable, getImplementationMethod, getInstructionInfo, getIntrinsicDependencies, getLineNumber, getLocationId, getParentExpression, getPublicId, getSpecialProperties, getSystemId, markTailFunctionCalls, process, resetStaticProperties, setLocationId, setParentExpression, typeError`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### operand0

    protected Expression operand0

### operand1

    protected Expression operand1

### operator

    protected int operator

Constructor Detail

### RangeExpression

    public RangeExpression(Expression start,
                           int op,
                           Expression end)

  Construct a RangeExpression

Method Detail

### analyze

    public Expression analyze(StaticContext env,
                              ItemType contextItemType)
                       throws XPathException

  Type-check the expression

  Specified by:
    `analyze` in interface `Expression`
  Overrides:
    `analyze` in class `net.sf.saxon.expr.BinaryExpression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
    `XPathException`

### getItemType

    public ItemType getItemType()

  Get the data type of the items returned

  Returns:
    a value such as Type.STRING, Type.BOOLEAN, Type.NUMBER, Type.NODE, or Type.ITEM (meaning not known at compile time)

### computeCardinality

    public int computeCardinality()

  Determine the static cardinality

  Overrides:
    `computeCardinality` in class `net.sf.saxon.expr.BinaryExpression`

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Return an iteration over the sequence

  Specified by:
    `iterate` in interface `Expression`
  Overrides:
    `iterate` in class `ComputedExpression`
  Parameters:
    `context` - supplies the context for evaluation
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### simplify

    public Expression simplify(StaticContext env)
                        throws XPathException

  Simplify an expression

  Specified by:
    `simplify` in interface `Expression`
  Overrides:
    `simplify` in class `ComputedExpression`
  Returns:
    the simplified expression
  Throws:
    `XPathException` - if an error is discovered during expression rewriting

### promote

    public Expression promote(PromotionOffer offer)
                       throws XPathException

  Promote this expression if possible

  Specified by:
    `promote` in interface `Expression`
  Overrides:
    `promote` in class `ComputedExpression`
  Parameters:
    `offer` - details of the offer, for example the offer to move expressions that don't depend on the context to an outer level in the containing expression
  Returns:
    if the offer is not accepted, return this expression unchanged. Otherwise return the result of rewriting the expression to promote this subexpression
  Throws:
    `XPathException` - if any error is detected

### iterateSubExpressions

    public java.util.Iterator iterateSubExpressions()

  Get the immediate subexpressions of this expression

  Specified by:
    `iterateSubExpressions` in interface `Expression`
  Overrides:
    `iterateSubExpressions` in class `ComputedExpression`
  Returns:
    an iterator containing the sub-expressions of this expression

### isCommutative

    protected static boolean isCommutative(int operator)

### equals

    public boolean equals(java.lang.Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `java.lang.Object`

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions. Note that this hashcode gives the same result for (A op B) and for (B op A), whether or not the operator is commutative.

  Overrides:
    `hashCode` in class `java.lang.Object`

### display

    public void display(int level,
                        NamePool pool,
                        java.io.PrintStream out)

  Diagnostic print of expression structure

  Parameters:
    `level` - indentation level for this expression
    `pool` - NamePool used to expand any names appearing in the expression
    `out` - Output destination

### displayOperator

    protected java.lang.String displayOperator()